from fastapi import FastAPI
import urllib.parse

from config import __CONFIG__
import mysql_connector
from fastgpt_uploader import upload2fastgpt
from semanticscholar import search_paper

app = FastAPI()

def query(query:str):
    res = []
    list = search_paper(query)
    for i in list:
        if not mysql_connector.is_loaded(i['paperId']):
            print('New: '+i['q'])
            res.append({
                'id':i['paperId'],
                'q':str(i['citationStyles']['bibtex']), 
                'a':str(i['abstract']),
                'score':[]
                })
    print('New: '+len(res)+'/'+len(list))
    return res

@app.get("/fastdoi")
async def get_reference(questions):
    print('Search: '+questions)
    res = query(urllib.parse.quote(questions))
    if(upload2fastgpt(res)):
        for i in res:
            mysql_connector.new_load(i['id'])

    return res

if __name__ == '__main__':
    import uvicorn
    uvicorn.run(app, host="127.0.0.1", port=8964)
    mysql_connector.end_mysql()